import axios from 'axios'
import { Toast } from 'vant'
// 根据环境不同引入不同api地址
import { baseApi } from '@/config'
// create an axios instance
const service = axios.create({
        baseURL: baseApi, // url = base api url + request url
        withCredentials: true, // send cookies when cross-domain requests
        timeout: 10000 // request timeout
    })
    //.
    // request拦截器 request interceptor
service.interceptors.request.use(
        config => {
            // 不传递默认开启loading
            if (!config.hideloading) {
                // loading
                // Toast.loading({
                //   message: '加载中...',
                //   forbidClick: true,
                //   loadingType: 'spinner',
                // })
            }
            config.headers['X-Token'] = localStorage.getItem('hsayi-token') || '';
            return config
        },
        error => {
            // do something with request error
            console.log(error) // for debug
            return Promise.reject(error)
        }
    )
    // respone拦截器
service.interceptors.response.use(
    response => {
        Toast.clear()
        const res = response.data;
        if (res.code === 401) {
            localStorage.removeItem('hsayi-token')
                // location.reload()
            Toast(res.message)
            return Promise.reject(res.message);
        }
        if (res.code === 0 || response.request.responseType == 'blob' || res.code === 1000) {
            return response;
        } else {
            Toast(res.message)
        }
        return Promise.reject(res.message);
    },
    error => {
        Toast.clear()
        console.log('err' + error) // for debug
        Toast(error.message)
        return Promise.reject(error)
    }
)

export default service